#include "groupscreen.h"
#include "fetch_group.h"
#include "fonts.h"

GroupScreen::GroupScreen(pqxx::connection &conn, unsigned tournament, unsigned round, unsigned parallel)
	: tournament(tournament), round(round), parallel(parallel), scores_changed(conn, "scores"), conn(conn), valid(false)
{
}

GroupScreen::~GroupScreen()
{
}

bool GroupScreen::check_invalidated()
{
	// we might want to do this slightly more sophisticated later, but for now this will do
	return !valid || scores_changed.get_flag();
}

void GroupScreen::draw(unsigned char *buf)
{
	scores_changed.reset_flag();

	Group group;
	conn.perform(FetchGroup(tournament, round, parallel, &group));

	memset(buf, 0, 800 * 600 * 4);
	
	// just as a test, show all the players and the scores (no headings)
	unsigned y = 50;
	for (std::vector<Player>::const_iterator i = group.players.begin(); i != group.players.end(); ++i) {
		my_draw_text(i->nick, buf, 20, y, true, 255, 255, 255);

		unsigned x = 90;
		for (std::vector<Score>::const_iterator j = i->scores.begin(); j != i->scores.end(); ++j) {
			char text[16];
			sprintf(text, "%u", j->score);
			
			my_draw_text(text, buf, x, y, true, 255, 255, 255);
			x += 60;
		}

		y += 20;
	}
	
	valid = true;
}

